;---- iNESヘッダ
    .inesprg 1 ; PRG 16KB
    .ineschr 1 ; CHR 8KB
    .inesmap 0 ; マッパー0
    .inesmir 0 ; 水平ミラーリング


;---- bank0
    .bank 0
    .org $C000 
RESET:
    sei
    cld

    ; グラフィックを使うには起動後にVBlankを2回待つ必要がある
    ; お約束コードです
.vblankWait1   ; VBlank待ちその1
    bit $2002
    bpl .vblankWait1

.vblankWait2   ; VBlank待ちその2
    bit $2002
    bpl .vblankWait2

    ; これ以降グラフィック関連の処理ができる

    ; 2つのパレットを設定

    ; 最初にBGパレットを設定

    ; PPUステータスをリセット (お約束)
    lda $2002
    ; まずアドレス$3F00の上位バイト$3Fを書き込む
    lda #$3F
    sta $2006
    ; 次にアドレス$3F00の下位バイト$10を書き込む
    lda #$00
    sta $2006

    ; Xレジスタを0で初期化。ループ処理のカウンタとして使う。
    ldx #0
.loadBgPalette
    ; bgPalette + x のアドレスの値をロードして、$2007にストア
    lda bgPalette, x
    sta $2007

    ; Xレジスタの値をインクリメント(+1)
    inx
    ; Xレジスタの値を16(10進数)と比較   
    cpx #16
    ; Xレジスタがまだ16じゃなければ.loadBgPaletteローカルラベルに戻る
    bne .loadBgPalette
    ; Xレジスタが16だったら終了


    ; 続いてスプライト用パレットを設定

    ; PPUステータスをリセット (お約束)
    lda $2002
    ; まずアドレス$3F10の上位バイト$3Fを書き込む
    lda #$3F
    sta $2006
    ; 次にアドレス$3F10の下位バイト$10を書き込む
    lda #$10
    sta $2006

    ; Xレジスタを再度0で初期化。
    ldx #0
.loadSpritePalette
    ; spritePalette + x のアドレスの値をロードして、$2007にストア
    lda spritePalette, x
    sta $2007

    inx
    cpx #16
    bne .loadSpritePalette


    ; スプライトを2つ表示する

    ; 画面真ん中あたりにスプライトを1つ表示する

    ; Y座標は$80
    lda #$80
    sta $0200 

    ; タイル$20番を表示する。
    lda #$20
    sta $0201

    ; 属性の指定。サブパレットは%01。画像の反転などはしない。
    lda #%00000001
    sta $0202

    ; X座標は$80
    lda #$80
    sta $0203


    ; 画面下の方にもうひとつスプライトを表示する
    ; Y座標は$D0
    lda #$B0
    sta $0204

    ; タイル$20番を表示する
    lda #$020
    sta $0205

    ; 属性の指定。サブパレットは%11。画像の反転などはしない
    lda #%00000011
    sta $0206

    ; Z座標は$80
    lda #$80
    sta $0207


    ; 以下PPUのコントロールポートの設定
    ; NMIを発生させる。スプライトはPPUアドレス$1000からロード
    lda #%10001000
    sta $2000

    ; スプライトを有効にする。
    lda #%00011000
    sta $2001


    ; 無限ループに入って、あとはNMIハンドラで処理する。
.forever
    jmp .forever
  

NMI:
    ; スプライトDMA転送 ($0200-$02FFからPPUのOAMに転送)
    lda #$00
    sta $2003
    lda #$02
    sta $4014
    rti

IRQ:
    rti


;---- パレットの定義。

;---- スプライト用パレット
;---- 区画ごとにグレー、青、赤、緑な並びにする。
spritePalette:
    .byte $0D, $01, $05, $09
    .byte $0D, $11, $15, $19
    .byte $0D, $21, $25, $29
    .byte $0D, $31, $35, $39

;---- BG用パレット。てきとう。
bgPalette:
    .byte $01, $32, $36, $3A
    .byte $01, $22, $26, $2A
    .byte $01, $12, $16, $1A
    .byte $01, $02, $06, $0A



;---- bank1
    .bank 1
    .org $FFFA
    .word NMI
    .word RESET
    .word IRQ


;---- bank2 (CHR bank0)
;---- 外部ファイル07.chrをパターンテーブルにマッピング
    .bank 2
    .org $0000
    .incbin "07.chr"

